﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Threading.Tasks;
using System.Web.Http;

namespace PollyWebApi2DI.Controllers.Remote
{
    [RoutePrefix("api/PersonCalculator")]
    public class PersonCalculatorController : ApiController
    {
        private readonly Random _random;
        public PersonCalculatorController()
        {
            _random = new Random();
        }
        static int _attempts = 0;

        public async Task<IHttpActionResult> Get()
        {
            int delay = _random.Next(200, 400);
            await Task.Delay(delay); // Simulate some heavy processing
            _attempts++;

            if (delay < 250) // only some of the requests will succeed
            {
                return Ok(_attempts);
            }

            return Content(HttpStatusCode.RequestTimeout, "Timeout due to stars not aligning");
        }
    }
}
